/**************************************************************************
  This macro is partially based on "Display Scheme", developed by George de
  Bruin in August, 1996, and heavily based on "Scheme", developed
  by Carlo Hogeveen in June 1999.
 **************************************************************************/

/**************************************************************************
  Change the name of the specified scheme
 **************************************************************************/
integer proc rename_scheme(string old_scheme_name, string scheme_file)
    string new_scheme_name[255] = old_scheme_name

    if Ask('Rename "' + old_scheme_name + '" to :', new_scheme_name) and new_scheme_name <> ""
        RenameProfileSection(old_scheme_name, new_scheme_name, scheme_file)
        return (TRUE)
    endif
    return (FALSE)
end

/**************************************************************************
  Update the colors of the specified scheme with the current
  editor colors.
 **************************************************************************/
proc update_scheme(string scheme_name, string scheme_file)
    writeprofileint(scheme_name, "CurrWinBorderAttr"  , Query(CurrWinBorderAttr)  , scheme_file)
    writeprofileint(scheme_name, "OtherWinBorderAttr" , Query(OtherWinBorderAttr) , scheme_file)
    writeprofileint(scheme_name, "MenuTextAttr"       , Query(MenuTextAttr)       , scheme_file)
    writeprofileint(scheme_name, "MenuTextLtrAttr"    , Query(MenuTextLtrAttr)    , scheme_file)
    writeprofileint(scheme_name, "MenuGrayAttr"       , Query(MenuGrayAttr)       , scheme_file)
    writeprofileint(scheme_name, "MenuSelectGrayAttr" , Query(MenuSelectGrayAttr) , scheme_file)
    writeprofileint(scheme_name, "MenuBorderAttr"     , Query(MenuBorderAttr)     , scheme_file)
    writeprofileint(scheme_name, "MenuSelectAttr"     , Query(MenuSelectAttr)     , scheme_file)
    writeprofileint(scheme_name, "MenuSelectLtrAttr"  , Query(MenuSelectLtrAttr)  , scheme_file)
    writeprofileint(scheme_name, "BlockAttr"          , Query(BlockAttr)          , scheme_file)
    writeprofileint(scheme_name, "CursorInBlockAttr"  , Query(CursorInBlockAttr)  , scheme_file)
    writeprofileint(scheme_name, "CursorAttr"         , Query(CursorAttr)         , scheme_file)
    writeprofileint(scheme_name, "HiLiteAttr"         , Query(HiLiteAttr)         , scheme_file)
    writeprofileint(scheme_name, "TextAttr"           , Query(TextAttr)           , scheme_file)
    writeprofileint(scheme_name, "EOFMarkerAttr"      , Query(EOFMarkerAttr)      , scheme_file)
    writeprofileint(scheme_name, "MsgAttr"            , Query(MsgAttr)            , scheme_file)
    writeprofileint(scheme_name, "StatusLineAttr"     , Query(StatusLineAttr)     , scheme_file)
    writeprofileint(scheme_name, "HelpInfoAttr"       , Query(HelpInfoAttr)       , scheme_file)
    writeprofileint(scheme_name, "HelpLinkAttr"       , Query(HelpLinkAttr)       , scheme_file)
    writeprofileint(scheme_name, "HelpSelectAttr"     , Query(HelpSelectAttr)     , scheme_file)
    writeprofileint(scheme_name, "HelpBoldAttr"       , Query(HelpBoldAttr)       , scheme_file)
    writeprofileint(scheme_name, "HelpItalicsAttr"    , Query(HelpItalicsAttr)    , scheme_file)
    writeprofileint(scheme_name, "HelpTextAttr"       , Query(HelpTextAttr)       , scheme_file)
    writeprofileint(scheme_name, "IncompleteQuoteAttr", Query(IncompleteQuoteAttr), scheme_file)
    writeprofileint(scheme_name, "NumberAttr"         , Query(NumberAttr)         , scheme_file)
    writeprofileint(scheme_name, "Directive1Attr"     , Query(Directive1Attr)     , scheme_file)
    writeprofileint(scheme_name, "Directive2Attr"     , Query(Directive2Attr)     , scheme_file)
    writeprofileint(scheme_name, "Directive3Attr"     , Query(Directive3Attr)     , scheme_file)
    writeprofileint(scheme_name, "MultiLnDlmt1Attr"   , Query(MultiLnDlmt1Attr)   , scheme_file)
    writeprofileint(scheme_name, "MultiLnDlmt2Attr"   , Query(MultiLnDlmt2Attr)   , scheme_file)
    writeprofileint(scheme_name, "MultiLnDlmt3Attr"   , Query(MultiLnDlmt3Attr)   , scheme_file)
    writeprofileint(scheme_name, "SingleLnDlmt1Attr"  , Query(SingleLnDlmt1Attr)  , scheme_file)
    writeprofileint(scheme_name, "SingleLnDlmt2Attr"  , Query(SingleLnDlmt2Attr)  , scheme_file)
    writeprofileint(scheme_name, "SingleLnDlmt3Attr"  , Query(SingleLnDlmt3Attr)  , scheme_file)
    writeprofileint(scheme_name, "Quote1Attr"         , Query(Quote1Attr)         , scheme_file)
    writeprofileint(scheme_name, "Quote2Attr"         , Query(Quote2Attr)         , scheme_file)
    writeprofileint(scheme_name, "Quote3Attr"         , Query(Quote3Attr)         , scheme_file)
    writeprofileint(scheme_name, "ToEOL1Attr"         , Query(ToEOL1Attr)         , scheme_file)
    writeprofileint(scheme_name, "ToEOL2Attr"         , Query(ToEOL2Attr)         , scheme_file)
    writeprofileint(scheme_name, "ToEOL3Attr"         , Query(ToEOL3Attr)         , scheme_file)
    writeprofileint(scheme_name, "KeyWords1Attr"      , Query(KeyWords1Attr)      , scheme_file)
    writeprofileint(scheme_name, "KeyWords2Attr"      , Query(KeyWords2Attr)      , scheme_file)
    writeprofileint(scheme_name, "KeyWords3Attr"      , Query(KeyWords3Attr)      , scheme_file)
    writeprofileint(scheme_name, "KeyWords4Attr"      , Query(KeyWords4Attr)      , scheme_file)
    writeprofileint(scheme_name, "KeyWords5Attr"      , Query(KeyWords5Attr)      , scheme_file)
    writeprofileint(scheme_name, "KeyWords6Attr"      , Query(KeyWords6Attr)      , scheme_file)
    writeprofileint(scheme_name, "KeyWords7Attr"      , Query(KeyWords7Attr)      , scheme_file)
    writeprofileint(scheme_name, "KeyWords8Attr"      , Query(KeyWords8Attr)      , scheme_file)
    writeprofileint(scheme_name, "KeyWords9Attr"      , Query(KeyWords9Attr)      , scheme_file)
end

/**************************************************************************
  Load the specified scheme
 **************************************************************************/
proc load_scheme(string scheme_name, string scheme_file)
    Set(CurrWinBorderAttr  , getprofileint(scheme_name, "CurrWinBorderAttr"  , Query(CurrWinBorderAttr)  , scheme_file))
    Set(OtherWinBorderAttr , getprofileint(scheme_name, "OtherWinBorderAttr" , Query(OtherWinBorderAttr) , scheme_file))
    Set(MenuTextAttr       , getprofileint(scheme_name, "MenuTextAttr"       , Query(MenuTextAttr)       , scheme_file))
    Set(MenuTextLtrAttr    , getprofileint(scheme_name, "MenuTextLtrAttr"    , Query(MenuTextLtrAttr)    , scheme_file))
    Set(MenuGrayAttr       , getprofileint(scheme_name, "MenuGrayAttr"       , Query(MenuGrayAttr)       , scheme_file))
    Set(MenuSelectGrayAttr , getprofileint(scheme_name, "MenuSelectGrayAttr" , Query(MenuSelectGrayAttr) , scheme_file))
    Set(MenuBorderAttr     , getprofileint(scheme_name, "MenuBorderAttr"     , Query(MenuBorderAttr)     , scheme_file))
    Set(MenuSelectAttr     , getprofileint(scheme_name, "MenuSelectAttr"     , Query(MenuSelectAttr)     , scheme_file))
    Set(MenuSelectLtrAttr  , getprofileint(scheme_name, "MenuSelectLtrAttr"  , Query(MenuSelectLtrAttr)  , scheme_file))
    Set(BlockAttr          , getprofileint(scheme_name, "BlockAttr"          , Query(BlockAttr)          , scheme_file))
    Set(CursorInBlockAttr  , getprofileint(scheme_name, "CursorInBlockAttr"  , Query(CursorInBlockAttr)  , scheme_file))
    Set(CursorAttr         , getprofileint(scheme_name, "CursorAttr"         , Query(CursorAttr)         , scheme_file))
    Set(HiLiteAttr         , getprofileint(scheme_name, "HiLiteAttr"         , Query(HiLiteAttr)         , scheme_file))
    Set(TextAttr           , getprofileint(scheme_name, "TextAttr"           , Query(TextAttr)           , scheme_file))
    Set(EOFMarkerAttr      , getprofileint(scheme_name, "EOFMarkerAttr"      , Query(EOFMarkerAttr)      , scheme_file))
    Set(MsgAttr            , getprofileint(scheme_name, "MsgAttr"            , Query(MsgAttr)            , scheme_file))
    Set(StatusLineAttr     , getprofileint(scheme_name, "StatusLineAttr"     , Query(StatusLineAttr)     , scheme_file))
    Set(HelpInfoAttr       , getprofileint(scheme_name, "HelpInfoAttr"       , Query(HelpInfoAttr)       , scheme_file))
    Set(HelpLinkAttr       , getprofileint(scheme_name, "HelpLinkAttr"       , Query(HelpLinkAttr)       , scheme_file))
    Set(HelpSelectAttr     , getprofileint(scheme_name, "HelpSelectAttr"     , Query(HelpSelectAttr)     , scheme_file))
    Set(HelpBoldAttr       , getprofileint(scheme_name, "HelpBoldAttr"       , Query(HelpBoldAttr)       , scheme_file))
    Set(HelpItalicsAttr    , getprofileint(scheme_name, "HelpItalicsAttr"    , Query(HelpItalicsAttr)    , scheme_file))
    Set(HelpTextAttr       , getprofileint(scheme_name, "HelpTextAttr"       , Query(HelpTextAttr)       , scheme_file))
    Set(IncompleteQuoteAttr, getprofileint(scheme_name, "IncompleteQuoteAttr", Query(IncompleteQuoteAttr), scheme_file))
    Set(NumberAttr         , getprofileint(scheme_name, "NumberAttr"         , Query(NumberAttr)         , scheme_file))
    Set(Directive1Attr     , getprofileint(scheme_name, "Directive1Attr"     , Query(Directive1Attr)     , scheme_file))
    Set(Directive2Attr     , getprofileint(scheme_name, "Directive2Attr"     , Query(Directive2Attr)     , scheme_file))
    Set(Directive3Attr     , getprofileint(scheme_name, "Directive3Attr"     , Query(Directive3Attr)     , scheme_file))
    Set(MultiLnDlmt1Attr   , getprofileint(scheme_name, "MultiLnDlmt1Attr"   , Query(MultiLnDlmt1Attr)   , scheme_file))
    Set(MultiLnDlmt2Attr   , getprofileint(scheme_name, "MultiLnDlmt2Attr"   , Query(MultiLnDlmt2Attr)   , scheme_file))
    Set(MultiLnDlmt3Attr   , getprofileint(scheme_name, "MultiLnDlmt3Attr"   , Query(MultiLnDlmt3Attr)   , scheme_file))
    Set(SingleLnDlmt1Attr  , getprofileint(scheme_name, "SingleLnDlmt1Attr"  , Query(SingleLnDlmt1Attr)  , scheme_file))
    Set(SingleLnDlmt2Attr  , getprofileint(scheme_name, "SingleLnDlmt2Attr"  , Query(SingleLnDlmt2Attr)  , scheme_file))
    Set(SingleLnDlmt3Attr  , getprofileint(scheme_name, "SingleLnDlmt3Attr"  , Query(SingleLnDlmt3Attr)  , scheme_file))
    Set(Quote1Attr         , getprofileint(scheme_name, "Quote1Attr"         , Query(Quote1Attr)         , scheme_file))
    Set(Quote2Attr         , getprofileint(scheme_name, "Quote2Attr"         , Query(Quote2Attr)         , scheme_file))
    Set(Quote3Attr         , getprofileint(scheme_name, "Quote3Attr"         , Query(Quote3Attr)         , scheme_file))
    Set(ToEOL1Attr         , getprofileint(scheme_name, "ToEOL1Attr"         , Query(ToEOL1Attr)         , scheme_file))
    Set(ToEOL2Attr         , getprofileint(scheme_name, "ToEOL2Attr"         , Query(ToEOL2Attr)         , scheme_file))
    Set(ToEOL3Attr         , getprofileint(scheme_name, "ToEOL3Attr"         , Query(ToEOL3Attr)         , scheme_file))
    Set(KeyWords1Attr      , getprofileint(scheme_name, "KeyWords1Attr"      , Query(KeyWords1Attr)      , scheme_file))
    Set(KeyWords2Attr      , getprofileint(scheme_name, "KeyWords2Attr"      , Query(KeyWords2Attr)      , scheme_file))
    Set(KeyWords3Attr      , getprofileint(scheme_name, "KeyWords3Attr"      , Query(KeyWords3Attr)      , scheme_file))
    Set(KeyWords4Attr      , getprofileint(scheme_name, "KeyWords4Attr"      , Query(KeyWords4Attr)      , scheme_file))
    Set(KeyWords5Attr      , getprofileint(scheme_name, "KeyWords5Attr"      , Query(KeyWords5Attr)      , scheme_file))
    Set(KeyWords6Attr      , getprofileint(scheme_name, "KeyWords6Attr"      , Query(KeyWords6Attr)      , scheme_file))
    Set(KeyWords7Attr      , getprofileint(scheme_name, "KeyWords7Attr"      , Query(KeyWords7Attr)      , scheme_file))
    Set(KeyWords8Attr      , getprofileint(scheme_name, "KeyWords8Attr"      , Query(KeyWords8Attr)      , scheme_file))
    Set(KeyWords9Attr      , getprofileint(scheme_name, "KeyWords9Attr"      , Query(KeyWords9Attr)      , scheme_file))
end

/**************************************************************************
  Add a new scheme
 **************************************************************************/
integer proc add_scheme(string scheme_file)
    string scheme_name[255] = ""

    if Ask("Save current color scheme as:", scheme_name) and scheme_name <> ""
        update_scheme(scheme_name, scheme_file)
        return (TRUE)
   endif
   return (FALSE)
end

/**************************************************************************
  Get a (sorted) list of the scheme section names into an editor buffer
 **************************************************************************/
proc build_scheme_buffer(var integer scheme_buffer, string scheme_file)
   integer msg_level
   string scheme_name[255] = ""

   PushPosition()

   if scheme_buffer == 0
      scheme_buffer = CreateTempBuffer()
   else
      GotoBufferId(scheme_buffer)
      EmptyBuffer()
   endif

   if loadprofilesectionnames(scheme_file)
      while getnextprofilesectionname(scheme_name)
         AddLine(scheme_name, scheme_buffer)
      endwhile
   endif

   PushBlock()
   MarkLine(1, NumLines())
   msg_level = Set(MsgLevel, _WARNINGS_ONLY_)
   Sort(_IGNORE_CASE_)
   Set(MsgLevel, msg_level)
   PopBlock()

   PopPosition()
end

constant kADD = -1, kUPDATE = -2, kRENAME = -3, kDELETE = -4, kPalette = -5

keydef list_keys
<cursorup>    if not up() endfile() begline() endif
<cursordown>  if not down() begfile() endif
<Ins>         EndProcess(kADD)
<Alt u>       EndProcess(kUPDATE)
<Alt r>       EndProcess(kRENAME)
<Del>         EndProcess(kDELETE)
<Alt p>       EndProcess(kPalette)
end

string list_footer[] = "{Enter}-Load {Ins}-Add {Alt-U}-Update {Alt-R}-Ren {Del}-Del {Alt-P}-Palette {Esc}-Exit"
//string list_footer[] = "{Enter}-Load {Ins}-Add {Alt-U}-Update {Alt-R}-Ren {Del}-Del {Esc}-Exit"

proc list_startup()
    UnHook(list_startup)
    enable(list_keys)
    ListFooter(list_footer)
end

integer scheme_buffer

proc main()
    integer result, cur_id, first_time, palette, esc_pressed
    string scheme_file[_MAXPATH_], scheme_name[255]

    cur_id = GetBufferId()
    scheme_file = SearchPath("colors.ini", "", ".")

    build_scheme_buffer(scheme_buffer, scheme_file)
    first_time = TRUE
    palette = false
    esc_pressed = false
    repeat
        if palette
            ExecMacro("setpalette -x")
            palette = false
        endif
        GotoBufferId(scheme_buffer)
        if first_time
            BegFile()
            first_time = FALSE
        endif
        Hook(_LIST_STARTUP_, list_startup)
        Set(Y1, 4)
        BufferVideo()
        result = List("Color Schemes", Max(LongestLineInBuffer(), Length(list_footer) - 12))
        scheme_name = GetText(1, CurrLineLen())
        GotoBufferId(cur_id)
        case result
            // add a new scheme
            when kADD
                if add_scheme(scheme_file)
                    build_scheme_buffer(scheme_buffer, scheme_file)
                endif
            // update an existing scheme using current color settings
            when KUPDATE
                update_scheme(scheme_name, scheme_file)
            // delete a scheme
            when kDELETE
                removeprofilesection(scheme_name, scheme_file)
                build_scheme_buffer(scheme_buffer, scheme_file)
            // rename a scheme
            when kRENAME
                if rename_scheme(scheme_name, scheme_file)
                    build_scheme_buffer(scheme_buffer, scheme_file)
                endif
            when kPalette
                palette = true
            // load a scheme
            when TRUE
                load_scheme(scheme_name, scheme_file)
                GotoBufferId(scheme_buffer)
                if not Down()
                   BegFile()
                endif
                GotoBufferId(cur_id)
                UpdateDisplay(_ALL_WINDOWS_REFRESH_)
                VirtualToRealScreen()
            // escape pressed
            when FALSE
                esc_pressed = true
        endcase
        UnBufferVideo()
    until esc_pressed
end

